require 'digest/sha1'
require 'net/http'

require 'openssl'
OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE
require 'yaml'

class Doku
  file_path = File.join(File.dirname(__FILE__),"properties.yml")
  @properties = YAML.load_file(file_path)
  def self.get_times
    Time.now.strftime("%d%m%Y%H%M%S")
  end

  def self.get_properties
    @properties
  end

  def self.do_sha1(data)
    Digest::SHA1.hexdigest(data)
  end

  def self.format_basket(basket)
    if !basket.nil?
      basket.to_sentence(two_words_connector: ';')
    end
  end

  def self.do_create_words(data, sharekey, withreq)
    device_id = 'device_id'
    pairing_codes = 'pairing_code'
    amount = 'amount'
    mall_id = 'mall_id'
    trans_id = 'trans_id'
    currency = 'currency'
    token = 'token'
    if withreq == 1
      device_id = 'req_device_id'
      pairing_codes = 'req_pairing_code'
      amount = 'req_amount'
      mall_id = 'req_mall_id'
      trans_id = 'req_trans_id_merchant'
      currency = 'req_currency'
      token = 'req_token_id'
    end

    if data.with_indifferent_access[device_id].to_s != ''
      if data.with_indifferent_access[pairing_codes].to_s != ''
        Digest::SHA1.hexdigest(data.with_indifferent_access[amount].to_s + data.with_indifferent_access[mall_id].to_s + sharekey + data.with_indifferent_access[trans_id].to_s + data.with_indifferent_access[currency].to_s + data.with_indifferent_access[token].to_s + data.with_indifferent_access[pairing_codes].to_s + data.with_indifferent_access[device_id].to_s)
      else
        Digest::SHA1.hexdigest(data.with_indifferent_access[amount].to_s + data.with_indifferent_access[mall_id].to_s + sharekey + data.with_indifferent_access[trans_id].to_s + data.with_indifferent_access[currency].to_s + data.with_indifferent_access[device_id].to_s)
      end
    elsif data.with_indifferent_access[pairing_codes].to_s != ''
      Digest::SHA1.hexdigest(data.with_indifferent_access[amount].to_s + data.with_indifferent_access[mall_id].to_s + sharekey + data.with_indifferent_access[trans_id].to_s + data.with_indifferent_access[currency].to_s + data.with_indifferent_access[token].to_s + data.with_indifferent_access[pairing_codes].to_s)
    elsif data.with_indifferent_access[currency].to_s != ''
      Digest::SHA1.hexdigest(data.with_indifferent_access[amount].to_s + data.with_indifferent_access[mall_id].to_s + sharekey + data.with_indifferent_access[trans_id].to_s + data.with_indifferent_access[currency].to_s)
    else
      Digest::SHA1.hexdigest(data.with_indifferent_access[amount].to_s + data.with_indifferent_access[mall_id].to_s + sharekey + data.with_indifferent_access[trans_id].to_s)
    end

  end

  def self.do_create_words_raw(data, sharekey)
    if data.with_indifferent_access['device_id'].to_s != ''
      if data.with_indifferent_access['pairing_code'].to_s != ''
        (data.with_indifferent_access['amount'].to_s + data.with_indifferent_access['mall_id'].to_s + sharekey + data.with_indifferent_access['trans_id'].to_s + data.with_indifferent_access['currency'].to_s + data.with_indifferent_access['token'].to_s + data.with_indifferent_access['pairing_code'].to_s + data.with_indifferent_access['device_id'].to_s)
      else
        (data.with_indifferent_access['amount'].to_s + data.with_indifferent_access['mall_id'].to_s + sharekey + data.with_indifferent_access['trans_id'].to_s + data.with_indifferent_access['currency'].to_s + data.with_indifferent_access['device_id'].to_s)
      end
    elsif data.with_indifferent_access['pairing_code'].to_s != ''
      (data.with_indifferent_access['amount'].to_s + data.with_indifferent_access['mall_id'].to_s + sharekey + data.with_indifferent_access['trans_id'].to_s + data.with_indifferent_access['currency'].to_s + data.with_indifferent_access['token'].to_s + data.with_indifferent_access['pairing_code'].to_s)
    elsif data.with_indifferent_access['currency'].to_s != ''
      (data.with_indifferent_access['amount'].to_s + data.with_indifferent_access['mall_id'].to_s + sharekey + data.with_indifferent_access['trans_id'].to_s + data.with_indifferent_access['currency'].to_s)
    else
      (data.with_indifferent_access['amount'].to_s + data.with_indifferent_access['mall_id'].to_s + sharekey + data.with_indifferent_access['trans_id'].to_s)
    end
  end

  def self.do_pre_payment(param_data)
    if !param_data.nil?
      uri = URI.parse(@properties['production']['prepayment_url'])
      response = Net::HTTP.post_form(uri, {"data" => param_data})
      response.body
    end
  end

  def self.do_payment(param_data)
    if !param_data.nil?
      uri = URI.parse(@properties['production']['payment_url'])
      response = Net::HTTP.post_form(uri, {"data" => param_data})
      response.body
    end
  end

  def self.do_direct_payment(param_data)
    if !param_data.nil?
      uri = URI.parse(@properties['production']['direct_payment_url'])
      response = Net::HTTP.post_form(uri, {"data" => param_data})
      response.body
    end
  end

  def self.do_generate_paycode(param_data)
    if !param_data.nil?
      uri = URI.parse(@properties['production']['generate_code_url'])
      response = Net::HTTP.post_form(uri, {"data" => param_data})
      response.body
    end
  end

  def self.do_redirect_payment(param_data)
    if !param_data.nil?
      uri = URI.parse(@properties['production']['redirect_payment_url'])
      response = Net::HTTP.post_form(uri, {"data" => param_data})
      response.body
    end
  end

end